routes/web.php
<?php

use App\Http\Controllers\Backend\AuthController;
use App\Http\Controllers\Backend\AuthorController;
use App\Http\Controllers\Backend\BookController;
use App\Http\Controllers\Backend\CategoryController;
use App\Http\Controllers\Backend\DashboardController;
use App\Http\Controllers\Frontend\HomeController;
use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider and all of them will
| be assigned to the "web" middleware group. Make something great!
|
*/

//Route::get('/', function () {
//    return view('welcome');
//});

Route::get('admin/login', [AuthController::class, 'index'])->name('admin.login');
Route::post('login', [AuthController::class, 'login'])->name('login');

// frontend
Route::get('/', [HomeController::class, 'home'])->name('home');
Route::get('book-detail/{slug}', [HomeController::class, 'bookDetailBySlug'])->name('book-detail');

Route::group(['middleware' => ['auth']], function () {
    Route::get('logout', [AuthController::class, 'logout'])->name('logout');

//    Dashboard
    Route::get('dashboard', [DashboardController::class, 'index'])->name('dashboard');

//    Category
    Route::group(['prefix' => 'category'], function (){
        Route::get('index', [CategoryController::class, 'index'])->name('category.index');
        Route::get('create', [CategoryController::class, 'create'])->name('category.create');
        Route::post('store', [CategoryController::class, 'store'])->name('category.store');
        Route::get('edit/{category}', [CategoryController::class, 'edit'])->name('category.edit');
        Route::get('show/{category}', [CategoryController::class, 'show'])->name('category.show');
        Route::post('update/{category}', [CategoryController::class, 'update'])->name('category.update');
        Route::get('delete/{category}', [CategoryController::class, 'delete'])->name('category.delete');
    });

    //    Author
    Route::group(['prefix' => 'author'], function (){
        Route::get('index', [AuthorController::class, 'index'])->name('author.index');
        Route::get('create', [AuthorController::class, 'create'])->name('author.create');
        Route::post('store', [AuthorController::class, 'store'])->name('author.store');
        Route::get('edit/{author}', [AuthorController::class, 'edit'])->name('author.edit');
        Route::get('show/{author}', [AuthorController::class, 'show'])->name('author.show');
        Route::post('update/{author}', [AuthorController::class, 'update'])->name('author.update');
        Route::get('delete/{author}', [AuthorController::class, 'delete'])->name('author.delete');
    });

    //    Book
    Route::group(['prefix' => 'book'], function (){
        Route::get('index', [BookController::class, 'index'])->name('book.index');
        Route::get('create', [BookController::class, 'create'])->name('book.create');
        Route::post('store', [BookController::class, 'store'])->name('book.store');
        Route::get('edit/{book}', [BookController::class, 'edit'])->name('book.edit');
        Route::post('update/{book}', [BookController::class, 'update'])->name('book.update');
        Route::get('delete/{book}', [BookController::class, 'delete'])->name('book.delete');
    });

});

app/Models/Book.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Support\Str;

class Book extends Model
{
    use HasFactory;

    /**
     * The attributes that are mass assignable.
     *
     * @var array<int, string>
     */
    protected $fillable = [
        'title',
        'slug',
        'description',
        'book_no',
        'publication_date',
        'image',
        'is_active',
        'category_id',
        'author_id',
        'added_by',
        'updated_by'
    ];

    /**
     * Boot the model.
     */
    protected static function boot()
    {
        parent::boot();

        static::created(function ($book) {
            $book->slug = $book->createSlug($book->title);
            $book->save();
        });
    }

    /**
     * Write code on Method
     *
     * @return mixed
     */
    private function createSlug($title){
        if (static::whereSlug($slug = Str::slug($title))->exists()) {
            $max = static::whereTitle($title)->latest('id')->skip(1)->value('slug');

            if (is_numeric($max[-1])) {
                return preg_replace_callback('/(\d+)$/', function ($mathces) {
                    return $mathces[1] + 1;
                }, $max);
            }

            return "{$slug}-2";
        }

        return $slug;
    }

    /**
     * One to One Relationship with Category
     */
    public function category()
    {
        return $this->belongsTo(Category::class);
    }

    /**
     * One to One Relationship with Author
     */
    public function author()
    {
        return $this->belongsTo(Author::class);
    }

    /**
     * One to One Relationship with user
     */
    public function user_added()
    {
        return $this->belongsTo(User::class, 'added_by');
    }

    /**
     * One to One Relationship with user
     */
    public function user_updated()
    {
        return $this->belongsTo(User::class, 'updated_by');
    }

    public function getExcerptAttribute()
    {
        return substr($this->description,0, 50);
    }

    public function getExcerptFullAttribute()
    {
        return substr($this->description,0, 600);
    }
}

app/Http/Controllers/Backend/BookController.php
<?php

namespace App\Http\Controllers\Backend;

use App\Http\Controllers\Controller;
use App\Http\Requests\CreateBookRequest;
use App\Http\Requests\UpdateBookRequest;
use App\Models\Author;
use App\Models\Book;
use App\Models\Category;
use App\Repositories\Interfaces\BookInterface;
use Illuminate\Http\Request;

class BookController extends Controller
{
    private $bookRepository;

    public function __construct(BookInterface $bookRepository)
    {
        $this->bookRepository = $bookRepository;
    }
    /**
     * @return mixed
     */
    public function index(): mixed
    {
        $books = $this->bookRepository->index();
        return view('admin.book.index', compact('books'));
    }

    /**
     * @return mixed
     */
    public function create()
    {
        $categoryLists = Category::get();
        $authorLists = Author::get();
        return view('admin.book.create', compact('categoryLists', 'authorLists'));
    }

    /**
     * @param CreateBookRequest $request
     * @return mixed
     */
    public function store(CreateBookRequest $request)
    {
        $requestLists = $this->bookRepository->store($request->all());
        return redirect('book/index')->with('message', 'Book created successfully');
    }

    /**
     * @param Book $book
     * @return mixed
     */
    public function edit(Book $book)
    {
        $books = Book::where('id',$book->id)->with('category', 'author', 'user_added', 'user_updated')->first();
        $categoryLists = Category::get();
        $authorLists = Author::get();
        return view('admin.book.edit', compact('books', 'categoryLists', 'authorLists'));
    }

    /**
     * @param Book $book
     * @param UpdateBookRequest $request
     * @return mixed
     */
    public function update(Book $book, UpdateBookRequest $request)
    {
        $requestLists = $this->bookRepository->update($book->id, $request->all());
        return redirect('book/index')->with('info', 'Book updated successfully');
    }

    /**
     * @param Book $book
     * @return mixed
     */
    public function delete(Book $book)
    {
        $this->bookRepository->delete($book->id);
        return redirect('book/index')->with('warning', 'Book deleted successfully');
    }
}

resources/views/front/book/detail.blade.php
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    <title>Book Store</title>
    <meta name="keywords" content="Book Store" />
    <meta name="description" content="Book Store" />
    <link href="{{asset('assets/css/templatemo_style.css')}}" rel="stylesheet" type="text/css" />
</head>
<body>
<!--  Free CSS Templates from www.templatemo.com -->
<div id="templatemo_container">
    <div id="templatemo_menu">
        <ul>
            <li><a href="{{route('home')}}">Home</a></li>
            <li><a href="#" class="current">Search</a></li>
            <li><a href="index.html">Books</a></li>
            <li><a href="index.html">New Releases</a></li>
            <li><a href="#">Company</a></li>
            <li><a href="#">Contact</a></li>
        </ul>
    </div> <!-- end of menu -->

    <div id="templatemo_header">
        <div id="templatemo_special_offers">
            <p>
                <span>25%</span> discounts for
                purchase over $ 40
            </p>
            <a href="#" style="margin-left: 50px;">Read more...</a>
        </div>


        <div id="templatemo_new_books">
            <ul>
                <li>Suspen disse</li>
                <li>Maece nas metus</li>
                <li>In sed risus ac feli</li>
            </ul>
            <a href="#" style="margin-left: 50px;">Read more...</a>
        </div>
    </div> <!-- end of header -->

    <div id="templatemo_content">

        <div id="templatemo_content_left">
            <div class="templatemo_content_left_section">
                <h1>Categories</h1>
                <ul>
                    @foreach($categories as $category)
                        <li><a href="{{route('home',['category' => $category->id])}}">{{$category->name}}</a></li>
                    @endforeach
                </ul>
            </div>
            <div class="templatemo_content_left_section">
                <h1>Authors</h1>
                <ul>
                    @foreach($authors as $author)
                        <li><a href="{{route('home',['author' => $author->id])}}">{{$author->name}}</a></li>
                    @endforeach
                </ul>
            </div>

            <div class="templatemo_content_left_section">
                <a href="http://validator.w3.org/check?uri=referer"><img style="border:0;width:88px;height:31px" src="http://www.w3.org/Icons/valid-xhtml10" alt="Valid XHTML 1.0 Transitional" width="88" height="31" vspace="8" border="0" /></a>
                <a href="http://jigsaw.w3.org/css-validator/check/referer"><img style="border:0;width:88px;height:31px"  src="http://jigsaw.w3.org/css-validator/images/vcss-blue" alt="Valid CSS!" vspace="8" border="0" /></a>
            </div>
        </div> <!-- end of content left -->

        <div id="templatemo_content_right">
            <h1>{{$book->title}}<span>(by {{$book->author->name}})</span></h1>
            <div class="image_panel"><img src="{{asset('/books/'.$book->image)}}" alt="css template ad" height="150" width="100"/></div>
            <h2>Read the lessons - Watch the videos - Do the exercises</h2>
            <ul>
                <li>Category: <a href="#">{{$book->category->name}}</a></li>
                <li>Publish Date : {{$book->publication_date}}</li>
                <li>Book No : {{$book->book_no}}</li>
            </ul>

            <p>{!! $book->excerptfull !!}</p>
            <div class="cleaner_with_height">&nbsp;</div>

            <a href=""><img src="{{asset('assets/images/templatemo_ads.jpg')}}" alt="css template ad" /></a>
        </div> <!-- end of content right -->

        <div class="cleaner_with_height">&nbsp;</div>
    </div> <!-- end of content -->

    <div id="templatemo_footer">
        <a href="index.html">Home</a> | <a href="index.html">Search</a> | <a href="index.html">Books</a> | <a href="#">New Releases</a> | <a href="#">FAQs</a> | <a href="#">Contact Us</a><br />
        Copyright © 2048 <a href="#"><strong>Your Company Name</strong></a> | <a href="http://www.iwebsitetemplate.com" target="_parent">Website Templates</a> by <a href="http://www.templatemo.com" target="_parent">Free CSS Templates</a>
    </div> <!-- end of footer -->
    <!--  Free CSS Template www.templatemo.com -->
</div> <!-- end of container -->
<div align=center>This template  downloaded form <a href='http://all-free-download.com/free-website-templates/'>free website templates</a></div></body>
</html>

resources/views/front/book/index.blade.php
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8"/>
    <title>Book Store</title>
    <meta name="keywords" content="Book Store"/>
    <meta name="description" content="Book Store"/>
    <link href="{{asset('assets/css/templatemo_style.css')}}" rel="stylesheet" type="text/css"/>
</head>
<body>
<!--  Free CSS Templates from www.templatemo.com -->
<div id="templatemo_container">
    <div id="templatemo_menu">
        <ul>
            <li><a href="{{route('home')}}" class="current">Home</a></li>
            <li><a href="subpage.html">Search</a></li>
            <li><a href="subpage.html">Books</a></li>
            <li><a href="subpage.html">New Releases</a></li>
            <li><a href="#">Company</a></li>
            <li><a href="#">Contact</a></li>
        </ul>
    </div> <!-- end of menu -->

    <div id="templatemo_header">
        <div id="templatemo_special_offers">
            <p>
                <span>25%</span> discounts for
                purchase over $80
            </p>
            <a href="subpage.html" style="margin-left: 50px;">Read more...</a>
        </div>


        <div id="templatemo_new_books">
            <ul>
                <li>Suspen disse</li>
                <li>Maece nas metus</li>
                <li>In sed risus ac feli</li>
            </ul>
            <a href="subpage.html" style="margin-left: 50px;">Read more...</a>
        </div>
    </div> <!-- end of header -->

    <div id="templatemo_content">

        <div id="templatemo_content_left">
            <div class="templatemo_content_left_section">
                <h1>Categories</h1>
                <ul>
                    @foreach($categories as $category)
                        <li><a href="{{route('home',['category' => $category->id])}}">{{$category->name}}</a></li>
                    @endforeach
                </ul>
            </div>
            <div class="templatemo_content_left_section">
                <h1>Authors</h1>
                <ul>
                    @foreach($authors as $author)
                        <li><a href="{{route('home',['author' => $author->id])}}">{{$author->name}}</a></li>
                    @endforeach
                </ul>
            </div>

            <div class="templatemo_content_left_section">
                <a href="http://validator.w3.org/check?uri=referer"><img style="border:0;width:88px;height:31px"
                                                                         src="http://www.w3.org/Icons/valid-xhtml10"
                                                                         alt="Valid XHTML 1.0 Transitional" width="88"
                                                                         height="31" vspace="8" border="0"/></a>
                <a href="http://jigsaw.w3.org/css-validator/check/referer"><img style="border:0;width:88px;height:31px"
                                                                                src="http://jigsaw.w3.org/css-validator/images/vcss-blue"
                                                                                alt="Valid CSS!" vspace="8" border="0"/></a>
            </div>
        </div> <!-- end of content left -->

        <div id="templatemo_content_right">
            @foreach($books as $book)
                <div class="templatemo_product_box">
                    <h1>{{$book->title}} <span>(By {{$book->author->name}})</span></h1>
                    <img src="{{asset('/books/'.$book->image)}}" alt="image" height="100" width="100"/>
                    <div class="product_info">
                        <p>{!! $book->excerpt !!}</p>
                        <h3>Category:{{$book->category->name}}</h3>
{{--                        <div class="buy_now_button"><a href="subpage.html">Buy Now</a></div>--}}
                        <div class="detail_button"><a href="{{route('book-detail', ['slug' => $book->slug])}}">Detail</a></div>
                    </div>
                    <div class="cleaner">&nbsp;</div>
                </div>
            @endforeach
            <a href="subpage.html"><img src="{{asset('assets/images/templatemo_ads.jpg')}}" alt="ads"/></a>
        </div> <!-- end of content right -->

        <div class="cleaner_with_height">&nbsp;</div>
    </div> <!-- end of content -->

    <div id="templatemo_footer">

        <a href="subpage.html">Home</a> | <a href="subpage.html">Search</a> | <a href="subpage.html">Books</a> | <a
            href="#">New Releases</a> | <a href="#">FAQs</a> | <a href="#">Contact Us</a><br/>
        Copyright © 2048 <a href="#"><strong>Your Company Name</strong></a> | <a href="http://www.iwebsitetemplate.com"
                                                                                 target="_parent">Website Templates</a>
        by <a href="http://www.templatemo.com" target="_parent" title="free css templates">Free CSS Templates</a></div>
    <!-- end of footer -->
    <!--  Free CSS Template www.templatemo.com -->
</div> <!-- end of container -->
<div align=center>This template downloaded form <a href='http://all-free-download.com/free-website-templates/'>free
        website templates</a></div>
</body>
</html>